var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import React from 'react';
import { getClassName } from '@react-devui/utils';
import { registerComponentMate } from '../../utils';
import { useComponentConfig, usePrefixConfig } from '../root';
import { DFormGroup } from './FormGroup';
import { DFormItem } from './FormItem';
import { DFormUpdateContext } from './hooks';
export const DFormContext = React.createContext(null);
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DForm' });
export const DForm = (props) => {
    var _a;
    const _b = useComponentConfig(COMPONENT_NAME, props), { children, dUpdate, dLabelWidth, dLabelColon, dRequiredType = 'required', dLayout = 'horizontal', dInlineSpan = 6, dFeedbackIcon = false, dSize } = _b, restProps = __rest(_b, ["children", "dUpdate", "dLabelWidth", "dLabelColon", "dRequiredType", "dLayout", "dInlineSpan", "dFeedbackIcon", "dSize"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    return (_jsx(DFormContext.Provider, Object.assign({ value: {
            gLabelWidth: dLabelWidth !== null && dLabelWidth !== void 0 ? dLabelWidth : (dLayout === 'vertical' ? '100%' : 150),
            gLabelColon: dLabelColon !== null && dLabelColon !== void 0 ? dLabelColon : (dLayout === 'vertical' ? false : true),
            gRequiredType: dRequiredType,
            gLayout: dLayout,
            gInlineSpan: dInlineSpan,
            gFeedbackIcon: dFeedbackIcon,
            gSize: dSize,
        } }, { children: _jsx(DFormUpdateContext.Provider, Object.assign({ value: dUpdate }, { children: _jsx("form", Object.assign({}, restProps, { className: getClassName(restProps.className, `${dPrefix}form`, {
                    [`${dPrefix}form--${dSize}`]: dSize,
                    [`${dPrefix}form--${dLayout}`]: dLayout,
                }), autoComplete: (_a = restProps.autoComplete) !== null && _a !== void 0 ? _a : 'off', onSubmit: (e) => {
                    var _a;
                    (_a = restProps.onSubmit) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                    e.preventDefault();
                    e.stopPropagation();
                } }, { children: children })) })) })));
};
DForm.Group = DFormGroup;
DForm.Item = DFormItem;
