/// <reference types="react" />
export interface DBadgeProps extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    dValue: number;
    dTheme?: 'primary' | 'success' | 'warning' | 'danger';
    dColor?: string;
    dShowZero?: boolean;
    dMax?: number;
    dDot?: boolean;
    dOffset?: [number | string, number | string];
    dAlone?: boolean;
}
export declare function DBadge(props: DBadgeProps): JSX.Element | null;
